/*
 * Periphery.h
 *
 *      Author: Aleksey Gerasimenko
 *      gerasimenko.aleksey.n@gmail.com
 */
#include <math.h>
#include <stdint.h>

#include "PERIPHERY/AnalogFault.h"
// #include "PERIPHERY/CAN.h"
#include "PERIPHERY/DigitalIO.h"
#include "PERIPHERY/ExtADC.h"
#include "PERIPHERY/ExtDAC.h"
#include "PERIPHERY/FRAMInterface.h"
#include "PERIPHERY/PeripheryMap.h"
#include "PERIPHERY/PWMABCInterace.h"
#include "PERIPHERY/PWMSInterace.h"


#ifndef PERIPHERAL_PERIPHERAL_H_
#define PERIPHERAL_PERIPHERAL_H_

namespace PERIPHERY
{



struct PeripherySetup
{
    PERIPHERY::ExtADCSetup extadc;
    PERIPHERY::AnaloFaultSetup analog_faults;
    PeripherySetup():
        extadc(),
        analog_faults()
    {}
};//PeripheralSetupStructure




class Periphery
{
protected:
    uint16_t *p_memzone;
public:
    PERIPHERY::DigitalIO        dio;
    PERIPHERY::ExtADC           adc;
    PERIPHERY::ExtDAC           dac;
    PERIPHERY::FRAMInterface    fram;
    PERIPHERY::AnalogFault      analog_faults;
public:
    Periphery();
};

} /* namespace PERIPHERY */

#endif /* PERIPHERY_PERIPHERY_H_ */
